from Products.validation.interfaces import ivalidator

class CharactersValidator:

    __implements__ = (ivalidator,)

    def __init__(self, name):
        self.name = name

# number, short_description, long_description
    def __call__(self, value, *args, **kwargs):
        self.lines = {'number'            : [],
                      'short_description' : [],
                      'long_description'  : []}
                  
        # setup and check for item count errors:

        line_errors = []
        line_count = 1
        for character_string in value:
            number = ""
            short_description = ""
            long_description = ""

            try:
                items = eval('[%s]' % character_string)
            except:
                return "Mixed numeric and text input somewhere on line %d" % line_count
            if len(items) != 3:
                line_errors.append("%d" % line_count)
            else:
                number, short_description, long_description = items 
                self.lines['number'].append(number)
                self.lines['short_description'].append(short_description)
                self.lines['long_description'].append(long_description)
            line_count += 1
        if len(line_errors) > 0:
            return "Wrong number of items on lines: %s" % line_errors

        # check for basic conversion errors:

        error_message = ""
        errors = None

        errors = self.checkForNumberErrors()
        if errors:
            error_message = "number (field 1) error on lines: %s" % str(errors)
            return error_message

        errors = self.checkForShortDescriptionErrors()
        if errors:
            error_message = "short_description (field 2) error on lines: %s" % str(errors)
            return error_message

        errors = self.checkForLongDescriptionErrors()
        if errors:
            error_message = "long_description (field 3) error on lines: %s" % str(errors)
            return error_message

        return 1

    def checkForNumberErrors(self):
        line_errors = []
        count = 1
        for number in self.lines['number']:
            try:
                int(number)
            except:
                line_errors.append(count)
            if int(number) < 0:
                line_errors.append(count)
            count += 1
        if len(line_errors) > 0:
            return line_errors
        return None

    def checkForShortDescriptionErrors(self):
        return None

    def checkForLongDescriptionErrors(self):
        return None

